import edu.neu.ccs.buyer.Buyer;
import edu.neu.ccs.seller.Seller;
import gen.Assignment;
import gen.Derivative;
import gen.RawMaterial;
import gen.Type;

public class Main {
	public static void p(String s) {
		System.out.println(s);
	}

	public static void main(String args[]) throws Exception {
		//Sample functionality
		//See test cases for results
		p("************************************************");
		p("Seller");
		p("************************************************");
		Seller seller = new Seller(6, "seller");
		//Generating derivative
		Derivative d = seller.generateDerivative("d1");
		p("Derivative: " + d.print());
		//Generating raw material
		RawMaterial rm = seller.generateRawMaterial(10, Type.parse("type[170 119]"));
		p("Raw material: \n" + rm.print());

		p("************************************************");
		Buyer buyer = new Buyer(7, "buyer");
		p("Buyer");
		p("************************************************");
		p("Good buy? " + buyer.goodBuy(d));

		//Finding assignment
		Assignment assign = buyer.getFinishedProduct(rm); 
		p("Best assignment: " + assign.print());

		//Finding quality
		double quality = Buyer.findQuality(rm, assign);
		p("Best quality: " + quality);
	}

}
